<?php

define('BASE_CODE_PATH', realpath('..' . DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR);

require_once(BASE_CODE_PATH . 'code-includes.php');
requireCode(THIRD_PARTY_RELATIVE_PATH . 'email');

use ScottK\Lib\Database\Database;

$submissions = Database::query('select id, submitted, comments, name, email from contacts where was_sent = 0 order by id limit 1');
if ($submissions && count($submissions))
{
	foreach ($submissions as $submission)
	{
		sendNotification(
			'scottk.net Portfolio Contact Submission',
			buildHtmlMessage($submission),
			$submission->email,
			$submission->name
		);
		Database::update('contacts', ['was_sent' => 1], ['id' => $submission->id]);
	}
}