<?php

define('APP_PATH_FOLDER', 'App' . DIRECTORY_SEPARATOR);
define('LIBRARY_PATH_FOLDER', 'Lib' . DIRECTORY_SEPARATOR);
define('CONFIG_FOLDER', 'config');
define('THIRD_PARTY_FOLDER', 'ThirdParty' . DIRECTORY_SEPARATOR);

define('APP_RELATIVE_PATH', APP_PATH_FOLDER);
define('CONFIG_RELATIVE_PATH', APP_PATH_FOLDER . CONFIG_FOLDER);
define('LIBRARY_RELATIVE_PATH', LIBRARY_PATH_FOLDER);
define('THIRD_PARTY_RELATIVE_PATH', LIBRARY_RELATIVE_PATH . THIRD_PARTY_FOLDER);

define('APP_ABSOLUTE_PATH', BASE_CODE_PATH . APP_RELATIVE_PATH);
define('CONFIG_ABSOLUTE_PATH', BASE_CODE_PATH . CONFIG_RELATIVE_PATH);
define('LIBRARY_ABSOLUTE_PATH', BASE_CODE_PATH . LIBRARY_RELATIVE_PATH);
define('THIRD_PARTY_ABSOLUTE_PATH', LIBRARY_ABSOLUTE_PATH . THIRD_PARTY_FOLDER);

define('PHP_FILE_EXTENSION', '.php');

require_once(BASE_CODE_PATH . 'constants.php');

function apiResponse($status, $message = '')
{
	header($status);
	echo json_encode((object)[
		'message' => $message
	]);
}

function codePath($path):string
{
	return (is_array($path))
		? BASE_CODE_PATH . implode(DIRECTORY_SEPARATOR, $path)
		: BASE_CODE_PATH . $path;
}

function config($configSection)
{
	$config = json_decode(file_get_contents(BASE_CODE_PATH . 'settings.json'));
	return $config->$configSection;
}

function generateFormKey($formSeed, $sessionSeed)
{
	
	return hash('sha256', $formSeed . $sessionSeed);
}

function includeCode($path)
{
	include(codePath($path) . PHP_FILE_EXTENSION);
}

function requireCode($path)
{
	require_once(codePath($path) . PHP_FILE_EXTENSION);
}

requireCode([LIBRARY_RELATIVE_PATH . 'Bootstrap', 'Bootstrap']);
requireCode([LIBRARY_RELATIVE_PATH . 'Database', 'Database']);
requireCode([LIBRARY_RELATIVE_PATH . 'Request', 'Request']);
requireCode([LIBRARY_RELATIVE_PATH . 'Request', 'RequestArray']);
requireCode([LIBRARY_RELATIVE_PATH, 'Templates', 'Template']);